Merge branch 'jn/send-pack-error' into maint
[git/jnareb-git.git] / t / t0000-basic.sh
blobf688bd3ef5034e32983685cfae940df303b377cc
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 test_description='Test the very basics part #1.
8 The rest of the test suite does not check the basic operation of git
9 plumbing commands to work very carefully. Their job is to concentrate
10 on tricky features that caused bugs in the past to detect regression.
12 This test runs very basic features, like registering things in cache,
13 writing tree, etc.
15 Note that this test *deliberately* hard-codes many expected object
16 IDs. When object ID computation changes, like in the previous case of
17 swapping compression and hashing order, the person who is making the
18 modification *should* take notice and update the test vectors here.
21 ################################################################
22 # It appears that people try to run tests without building...
24 ../git >/dev/null
25 if test $? != 1
26 then
27 echo >&2 'You do not seem to have built git yet.'
28 exit 1
31 . ./test-lib.sh
33 ################################################################
34 # git init has been done in an empty repository.
35 # make sure it is empty.
37 find .git/objects -type f -print >should-be-empty
38 test_expect_success \
39 '.git/objects should be empty after git init in an empty repo.' \
40 'cmp -s /dev/null should-be-empty'
42 # also it should have 2 subdirectories; no fan-out anymore, pack, and info.
43 # 3 is counting "objects" itself
44 find .git/objects -type d -print >full-of-directories
45 test_expect_success \
46 '.git/objects should have 3 subdirectories.' \
47 'test $(wc -l < full-of-directories) = 3'
49 ################################################################
50 # Test harness
51 test_expect_success 'success is reported like this' '
54 test_expect_failure 'pretend we have a known breakage' '
55 false
58 test_expect_success 'pretend we have fixed a known breakage (run in sub test-lib)' "
59 mkdir passing-todo &&
60 (cd passing-todo &&
61 cat >passing-todo.sh <<EOF &&
62 #!$SHELL_PATH
64 test_description='A passing TODO test
66 This is run in a sub test-lib so that we do not get incorrect passing
67 metrics
70 # Point to the t/test-lib.sh, which isn't in ../ as usual
71 TEST_DIRECTORY=\"$TEST_DIRECTORY\"
72 . \"\$TEST_DIRECTORY\"/test-lib.sh
74 test_expect_failure 'pretend we have fixed a known breakage' '
78 test_done
79 EOF
80 chmod +x passing-todo.sh &&
81 ./passing-todo.sh >out 2>err &&
82 ! test -s err &&
83 cat >expect <<EOF &&
84 ok 1 - pretend we have fixed a known breakage # TODO known breakage
85 # fixed 1 known breakage(s)
86 # passed all 1 test(s)
87 1..1
88 EOF
89 test_cmp expect out)
91 test_set_prereq HAVEIT
92 haveit=no
93 test_expect_success HAVEIT 'test runs if prerequisite is satisfied' '
94 test_have_prereq HAVEIT &&
95 haveit=yes
97 donthaveit=yes
98 test_expect_success DONTHAVEIT 'unmet prerequisite causes test to be skipped' '
99 donthaveit=no
101 if test $haveit$donthaveit != yesyes
102 then
103 say "bug in test framework: prerequisite tags do not work reliably"
104 exit 1
107 test_set_prereq HAVETHIS
108 haveit=no
109 test_expect_success HAVETHIS,HAVEIT 'test runs if prerequisites are satisfied' '
110 test_have_prereq HAVEIT &&
111 test_have_prereq HAVETHIS &&
112 haveit=yes
114 donthaveit=yes
115 test_expect_success HAVEIT,DONTHAVEIT 'unmet prerequisites causes test to be skipped' '
116 donthaveit=no
118 donthaveiteither=yes
119 test_expect_success DONTHAVEIT,HAVEIT 'unmet prerequisites causes test to be skipped' '
120 donthaveiteither=no
122 if test $haveit$donthaveit$donthaveiteither != yesyesyes
123 then
124 say "bug in test framework: multiple prerequisite tags do not work reliably"
125 exit 1
128 clean=no
129 test_expect_success 'tests clean up after themselves' '
130 test_when_finished clean=yes
133 cleaner=no
134 test_expect_code 1 'tests clean up even after a failure' '
135 test_when_finished cleaner=yes &&
136 (exit 1)
139 if test $clean$cleaner != yesyes
140 then
141 say "bug in test framework: cleanup commands do not work reliably"
142 exit 1
145 test_expect_code 2 'failure to clean up causes the test to fail' '
146 test_when_finished "(exit 2)"
149 ################################################################
150 # Basics of the basics
152 # updating a new file without --add should fail.
153 test_expect_success 'git update-index without --add should fail adding.' '
154 test_must_fail git update-index should-be-empty
157 # and with --add it should succeed, even if it is empty (it used to fail).
158 test_expect_success \
159 'git update-index with --add should succeed.' \
160 'git update-index --add should-be-empty'
162 test_expect_success \
163 'writing tree out with git write-tree' \
164 'tree=$(git write-tree)'
166 # we know the shape and contents of the tree and know the object ID for it.
167 test_expect_success \
168 'validate object ID of a known tree.' \
169 'test "$tree" = 7bb943559a305bdd6bdee2cef6e5df2413c3d30a'
171 # Removing paths.
172 rm -f should-be-empty full-of-directories
173 test_expect_success 'git update-index without --remove should fail removing.' '
174 test_must_fail git update-index should-be-empty
177 test_expect_success \
178 'git update-index with --remove should be able to remove.' \
179 'git update-index --remove should-be-empty'
181 # Empty tree can be written with recent write-tree.
182 test_expect_success \
183 'git write-tree should be able to write an empty tree.' \
184 'tree=$(git write-tree)'
186 test_expect_success \
187 'validate object ID of a known tree.' \
188 'test "$tree" = 4b825dc642cb6eb9a060e54bf8d69288fbee4904'
190 # Various types of objects
191 # Some filesystems do not support symblic links; on such systems
192 # some expected values are different
193 mkdir path2 path3 path3/subp3
194 paths='path0 path2/file2 path3/file3 path3/subp3/file3'
195 for p in $paths
197 echo "hello $p" >$p
198 done
199 if test_have_prereq SYMLINKS
200 then
201 for p in $paths
203 ln -s "hello $p" ${p}sym
204 done
205 expectfilter=cat
206 expectedtree=087704a96baf1c2d1c869a8b084481e121c88b5b
207 expectedptree1=21ae8269cacbe57ae09138dcc3a2887f904d02b3
208 expectedptree2=3c5e5399f3a333eddecce7a9b9465b63f65f51e2
209 else
210 expectfilter='grep -v sym'
211 expectedtree=8e18edf7d7edcf4371a3ac6ae5f07c2641db7c46
212 expectedptree1=cfb8591b2f65de8b8cc1020cd7d9e67e7793b325
213 expectedptree2=ce580448f0148b985a513b693fdf7d802cacb44f
216 test_expect_success \
217 'adding various types of objects with git update-index --add.' \
218 'find path* ! -type d -print | xargs git update-index --add'
220 # Show them and see that matches what we expect.
221 test_expect_success \
222 'showing stage with git ls-files --stage' \
223 'git ls-files --stage >current'
225 $expectfilter >expected <<\EOF
226 100644 f87290f8eb2cbbea7857214459a0739927eab154 0 path0
227 120000 15a98433ae33114b085f3eb3bb03b832b3180a01 0 path0sym
228 100644 3feff949ed00a62d9f7af97c15cd8a30595e7ac7 0 path2/file2
229 120000 d8ce161addc5173867a3c3c730924388daedbc38 0 path2/file2sym
230 100644 0aa34cae68d0878578ad119c86ca2b5ed5b28376 0 path3/file3
231 120000 8599103969b43aff7e430efea79ca4636466794f 0 path3/file3sym
232 100644 00fb5908cb97c2564a9783c0c64087333b3b464f 0 path3/subp3/file3
233 120000 6649a1ebe9e9f1c553b66f5a6e74136a07ccc57c 0 path3/subp3/file3sym
235 test_expect_success \
236 'validate git ls-files output for a known tree.' \
237 'test_cmp expected current'
239 test_expect_success \
240 'writing tree out with git write-tree.' \
241 'tree=$(git write-tree)'
242 test_expect_success \
243 'validate object ID for a known tree.' \
244 'test "$tree" = "$expectedtree"'
246 test_expect_success \
247 'showing tree with git ls-tree' \
248 'git ls-tree $tree >current'
249 cat >expected <<\EOF
250 100644 blob f87290f8eb2cbbea7857214459a0739927eab154 path0
251 120000 blob 15a98433ae33114b085f3eb3bb03b832b3180a01 path0sym
252 040000 tree 58a09c23e2ca152193f2786e06986b7b6712bdbe path2
253 040000 tree 21ae8269cacbe57ae09138dcc3a2887f904d02b3 path3
255 test_expect_success SYMLINKS \
256 'git ls-tree output for a known tree.' \
257 'test_cmp expected current'
259 # This changed in ls-tree pathspec change -- recursive does
260 # not show tree nodes anymore.
261 test_expect_success \
262 'showing tree with git ls-tree -r' \
263 'git ls-tree -r $tree >current'
264 $expectfilter >expected <<\EOF
265 100644 blob f87290f8eb2cbbea7857214459a0739927eab154 path0
266 120000 blob 15a98433ae33114b085f3eb3bb03b832b3180a01 path0sym
267 100644 blob 3feff949ed00a62d9f7af97c15cd8a30595e7ac7 path2/file2
268 120000 blob d8ce161addc5173867a3c3c730924388daedbc38 path2/file2sym
269 100644 blob 0aa34cae68d0878578ad119c86ca2b5ed5b28376 path3/file3
270 120000 blob 8599103969b43aff7e430efea79ca4636466794f path3/file3sym
271 100644 blob 00fb5908cb97c2564a9783c0c64087333b3b464f path3/subp3/file3
272 120000 blob 6649a1ebe9e9f1c553b66f5a6e74136a07ccc57c path3/subp3/file3sym
274 test_expect_success \
275 'git ls-tree -r output for a known tree.' \
276 'test_cmp expected current'
278 # But with -r -t we can have both.
279 test_expect_success \
280 'showing tree with git ls-tree -r -t' \
281 'git ls-tree -r -t $tree >current'
282 cat >expected <<\EOF
283 100644 blob f87290f8eb2cbbea7857214459a0739927eab154 path0
284 120000 blob 15a98433ae33114b085f3eb3bb03b832b3180a01 path0sym
285 040000 tree 58a09c23e2ca152193f2786e06986b7b6712bdbe path2
286 100644 blob 3feff949ed00a62d9f7af97c15cd8a30595e7ac7 path2/file2
287 120000 blob d8ce161addc5173867a3c3c730924388daedbc38 path2/file2sym
288 040000 tree 21ae8269cacbe57ae09138dcc3a2887f904d02b3 path3
289 100644 blob 0aa34cae68d0878578ad119c86ca2b5ed5b28376 path3/file3
290 120000 blob 8599103969b43aff7e430efea79ca4636466794f path3/file3sym
291 040000 tree 3c5e5399f3a333eddecce7a9b9465b63f65f51e2 path3/subp3
292 100644 blob 00fb5908cb97c2564a9783c0c64087333b3b464f path3/subp3/file3
293 120000 blob 6649a1ebe9e9f1c553b66f5a6e74136a07ccc57c path3/subp3/file3sym
295 test_expect_success SYMLINKS \
296 'git ls-tree -r output for a known tree.' \
297 'test_cmp expected current'
299 test_expect_success \
300 'writing partial tree out with git write-tree --prefix.' \
301 'ptree=$(git write-tree --prefix=path3)'
302 test_expect_success \
303 'validate object ID for a known tree.' \
304 'test "$ptree" = "$expectedptree1"'
306 test_expect_success \
307 'writing partial tree out with git write-tree --prefix.' \
308 'ptree=$(git write-tree --prefix=path3/subp3)'
309 test_expect_success \
310 'validate object ID for a known tree.' \
311 'test "$ptree" = "$expectedptree2"'
313 cat >badobjects <<EOF
314 100644 blob 1000000000000000000000000000000000000000 dir/file1
315 100644 blob 2000000000000000000000000000000000000000 dir/file2
316 100644 blob 3000000000000000000000000000000000000000 dir/file3
317 100644 blob 4000000000000000000000000000000000000000 dir/file4
318 100644 blob 5000000000000000000000000000000000000000 dir/file5
321 rm .git/index
322 test_expect_success \
323 'put invalid objects into the index.' \
324 'git update-index --index-info < badobjects'
326 test_expect_success 'writing this tree without --missing-ok.' '
327 test_must_fail git write-tree
330 test_expect_success \
331 'writing this tree with --missing-ok.' \
332 'git write-tree --missing-ok'
335 ################################################################
336 rm .git/index
337 test_expect_success \
338 'git read-tree followed by write-tree should be idempotent.' \
339 'git read-tree $tree &&
340 test -f .git/index &&
341 newtree=$(git write-tree) &&
342 test "$newtree" = "$tree"'
344 $expectfilter >expected <<\EOF
345 :100644 100644 f87290f8eb2cbbea7857214459a0739927eab154 0000000000000000000000000000000000000000 M path0
346 :120000 120000 15a98433ae33114b085f3eb3bb03b832b3180a01 0000000000000000000000000000000000000000 M path0sym
347 :100644 100644 3feff949ed00a62d9f7af97c15cd8a30595e7ac7 0000000000000000000000000000000000000000 M path2/file2
348 :120000 120000 d8ce161addc5173867a3c3c730924388daedbc38 0000000000000000000000000000000000000000 M path2/file2sym
349 :100644 100644 0aa34cae68d0878578ad119c86ca2b5ed5b28376 0000000000000000000000000000000000000000 M path3/file3
350 :120000 120000 8599103969b43aff7e430efea79ca4636466794f 0000000000000000000000000000000000000000 M path3/file3sym
351 :100644 100644 00fb5908cb97c2564a9783c0c64087333b3b464f 0000000000000000000000000000000000000000 M path3/subp3/file3
352 :120000 120000 6649a1ebe9e9f1c553b66f5a6e74136a07ccc57c 0000000000000000000000000000000000000000 M path3/subp3/file3sym
354 test_expect_success \
355 'validate git diff-files output for a know cache/work tree state.' \
356 'git diff-files >current && test_cmp current expected >/dev/null'
358 test_expect_success \
359 'git update-index --refresh should succeed.' \
360 'git update-index --refresh'
362 test_expect_success \
363 'no diff after checkout and git update-index --refresh.' \
364 'git diff-files >current && cmp -s current /dev/null'
366 ################################################################
367 P=$expectedtree
368 test_expect_success \
369 'git commit-tree records the correct tree in a commit.' \
370 'commit0=$(echo NO | git commit-tree $P) &&
371 tree=$(git show --pretty=raw $commit0 |
372 sed -n -e "s/^tree //p" -e "/^author /q") &&
373 test "z$tree" = "z$P"'
375 test_expect_success \
376 'git commit-tree records the correct parent in a commit.' \
377 'commit1=$(echo NO | git commit-tree $P -p $commit0) &&
378 parent=$(git show --pretty=raw $commit1 |
379 sed -n -e "s/^parent //p" -e "/^author /q") &&
380 test "z$commit0" = "z$parent"'
382 test_expect_success \
383 'git commit-tree omits duplicated parent in a commit.' \
384 'commit2=$(echo NO | git commit-tree $P -p $commit0 -p $commit0) &&
385 parent=$(git show --pretty=raw $commit2 |
386 sed -n -e "s/^parent //p" -e "/^author /q" |
387 sort -u) &&
388 test "z$commit0" = "z$parent" &&
389 numparent=$(git show --pretty=raw $commit2 |
390 sed -n -e "s/^parent //p" -e "/^author /q" |
391 wc -l) &&
392 test $numparent = 1'
394 test_expect_success 'update-index D/F conflict' '
395 mv path0 tmp &&
396 mv path2 path0 &&
397 mv tmp path2 &&
398 git update-index --add --replace path2 path0/file2 &&
399 numpath0=$(git ls-files path0 | wc -l) &&
400 test $numpath0 = 1
403 test_expect_success SYMLINKS 'absolute path works as expected' '
404 mkdir first &&
405 ln -s ../.git first/.git &&
406 mkdir second &&
407 ln -s ../first second/other &&
408 mkdir third &&
409 dir="$(cd .git; pwd -P)" &&
410 dir2=third/../second/other/.git &&
411 test "$dir" = "$(test-path-utils make_absolute_path $dir2)" &&
412 file="$dir"/index &&
413 test "$file" = "$(test-path-utils make_absolute_path $dir2/index)" &&
414 basename=blub &&
415 test "$dir/$basename" = "$(cd .git && test-path-utils make_absolute_path "$basename")" &&
416 ln -s ../first/file .git/syml &&
417 sym="$(cd first; pwd -P)"/file &&
418 test "$sym" = "$(test-path-utils make_absolute_path "$dir2/syml")"
421 test_expect_success 'very long name in the index handled sanely' '
423 a=a && # 1
424 a=$a$a$a$a$a$a$a$a$a$a$a$a$a$a$a$a && # 16
425 a=$a$a$a$a$a$a$a$a$a$a$a$a$a$a$a$a && # 256
426 a=$a$a$a$a$a$a$a$a$a$a$a$a$a$a$a$a && # 4096
427 a=${a}q &&
429 >path4 &&
430 git update-index --add path4 &&
432 git ls-files -s path4 |
433 sed -e "s/ .*/ /" |
434 tr -d "\012"
435 echo "$a"
436 ) | git update-index --index-info &&
437 len=$(git ls-files "a*" | wc -c) &&
438 test $len = 4098
441 test_done